{$A+,B-,F-,I-,N-,O-,R-,S+,V-}
{$IFDEF Ver70}
{$G-,T-}
{$ENDIF}
{$IFDEF Ver60}
{$G-}
{$ENDIF}
{$M 16384,0,655360}
Program AttrConv;
uses Dos;
Type TFormat=(fmRecognize,fmPlain,fmUnix,fmMim,fmWD,fmLex,fmPrintFx,fmEpson);
Const ControlCodes:String[8]=^Z#8^B#0#255'\'#27#14#20;
      FormatName:Array[TFormat] of string[11]=('AutoDetect','Plain ASCII',
      'Unix style','MicroMir',
      'Word&Deal','Lexicon','PrintFX','Epson');
      BackedUp:Boolean=False;
const
{ਡ ⥪}
taScript     = $80;
taDoubleWide = $40;
taSuperscript= $20;
taSubScript  = $10;
taBold       = $08;
taUnderline  = $04;
taItalic     = $02;
taInverse    = $01;
taNormal     = 0;
var InFileName,OutFileName:String;
    InBuf,OutBuf:Pointer;
    S,A:String;
    Inf,OutF:Text;
    BufSize:LongInt;
    GlobalAttr,LocalAttr,PrevAttr:Byte;
    inFmt,OutFmt:TFormat;
    FormatCount:Integer;
    i:Integer;
Procedure Help;
{--------- 뤠 ᪠   ணࠬ  蠥    0}
begin
 Writeln('Usage:'#10'AC source_file [source_format] [dest_file] [dest_format]'#10);
 Writeln('Where format is one of following:');
 Writeln(#9'/M - Micromir editor');
 Writeln(#9'/L - Lexicon editor');
 Writeln(#9'/P - PrintFX printing program');
 Writeln(#9'/E - Epson compatible printer control codes');
 Writeln(#9'/A - Plain ASCII file (no attributes)');
 Writeln(#9'/U - Unix-style format (Backspaces).');
 Writeln(#9'/W - Word & Deal editor');
 Writeln(#9'/* - Autodetect (input only)');
 Writeln('if destination file is omitted, source file would be overwritten');
 Writeln('if no destination format is specified, Plain ASCII is assumed');
 Writeln('if no source format is specified, program tries to recognize it');
 Halt;
end;
Procedure Error(Msg:String);
{-----뤠 ᮮ饭  訡  ࠧ  ப 
      蠥 ணࠬ   1}
begin
 Writeln(Msg);
 Writeln('Type AC /? for help');
 halt;
end;
Procedure FileError(Code:Integer;FileName:String);
{-----뤠 ᮮ饭  訡 DOS  蠥 ணࠬ   Code
      Code -  訡 DOS
      FileName -  䠩,  ࠡ   ந諠 訡}
begin
 Case Code of
 2:Writeln('Cannot find file:',FileName);
 3:Writeln('Invalid path to ',FileName);
 4:Writeln('Too many open files');
 5:Writeln('Denied access to ',FileName);
 12:Writeln('Invalid access code ',FileMode);
 15:Writeln('Invalid drive');
 17:Writeln('Cannot rename accross drives');
 100,160:Writeln('Disk Error Reading ',FileName);
 101,161:Writeln('Disk error writing ',FileName);
 150:Writeln('Disk is write-protected');
 152:Writeln('Drive not ready');
 154:Writeln('CRC error in data reading file ',FileName);
 else
  Writeln('DOS Error N ',Code,' with file ',FileName);
 end;
 Halt(Code);
end;
Function FormatType(Ch:Char):TFormat;
{--------頥  ଠ  㪢   ப}
begin
 Case Ch of
 'A':FormatType:=fmPlain;
 'M':FormatType:=fmMim;
 'L':FormatType:=fmLex;
 'W':FormatType:=fmWd;
 'P':FormatType:=fmPrintFX;
 'E':FormatType:=fmEpson;
 'U':FormatType:=fmUnix;
 '*':FormatType:=fmRecognize;
 '?':Help;
 'H':Help;
 else
  Error('Unknown format type '+S);
 end;
 inc(formatCount);
end;
Procedure BackUp(var FileName:String);
{२뢠 室 䠩,    뫮 १}
var F:File;
    I:Integer;
    Path:PathStr;Name:NameStr;Ext,NewExt:ExtStr;
begin
 For i:=1 to length(FileNAme) do
  FileName[i]:=Upcase(FileName[i]);
 FSplit(FileName,Path,Name,Ext);
 if Ext='.BAK' then NewExt:='.BKP' else NewExt:='.BAK';
 Assign(F,Path+Name+NewExt);
 Erase(F);
 i:=IOResult;
 if (i<>0) and (i<>2) then
  FileError(i,Path+Name+NewExt);
 Assign(F,FileName);
 Rename(F,Path+Name+NewExt);
 i:=IoResult;
 if i<>0 then FileError(i,FileName);
 BackedUp:=True;
 Write('Backup copy of ',FileName,' saved as ');
 FileName:=Path+Name+NewExt;
 Writeln(FileName);
end;
Procedure ShutDown(ErrCode:Integer;FileName:String);
{⠭ status quo, ᫨  㦥  室 䠩 
 뢠 FileError}
begin
 Close(inF);
 Close(OutF);
 Erase(OutF);
 if BackedUp then Rename(InF,OutFileName);
 FileError(ErrCode,FileName);
end;
{********** ⢥ ࠡ *****************}
{------  ࠢ  ----------}
{         ⢥ ࠬ ᨬ,   ᯮ 
        砫 ࠢ饩 ᫥⥫쭮, 䠩, 㤠 
        ⠢ ᥡ   ⮬,  ਡ  
        ( -   ப  )   
        ⠭ ⥪,    ࠢ饩.}
Function ReadAttrPlain(var F:Text;code:Char):String;far;
Begin
 ReadAttrPlain:=Code;
end;
Function ReadAttrMim(Var F:Text;Code:Char):String;far;
var Ch:Char;
begin
 Read(F,Ch);
 LocalAttr:=ord(Ch) and $7F;
 ReadAttrMim:='';
end;
Function ReadAttrLex(var F:Text;Code:Char):String;far;
var Ch:Char;
begin
 Read(F,Ch);
 ReadAttrLex:='';
 Case ch of
 '_':LocalAttr:=LocalAttr or taUnderline;
 '.':LocalAttr:=LocalAttr and not taUnderline;
 '0':LocalAttr:=LocalAttr and taUnderline;
 '1':LocalAttr:= taItalic + (LocalAttr and taUnderLine);
 '2':LocalAttr:= taBold + (LocalAttr and taUnderLine);
 '3':LocalAttr:= taBold + taItalic + (LocalAttr and taUnderLine);
 '4':LocalAttr:= taSubScript + (LocalAttr and taUnderLine);
 '5':LocalAttr:= taSuperScript + (LocalAttr and taUnderLine);
 '6':LocalAttr:= taBold+taSubScript + (LocalAttr and taUnderLine);
 '7':LocalAttr:= taBold+taSuperScript + (LocalAttr and taUnderLine);
 else
  ReadAttrLex:=Code+ch;
 end;
end;
Function ReadAttrPrintFX(var F:Text;Code:Char):String;far;
var Ch,ch1:Char;
begin
 ReadAttrPrintFX:='';
 Read(F,Ch);
 Case ch of
 '','','':LocalAttr:=LocalAttr and not taScript;
 '':LocalAttr:=LocalAttr or taScript;
 '':LocalAttr:=LocalAttr or taBold;
 '':LocalAttr:=LocalAttr and not taBold;
 '1':begin
      Read(F,Ch1);
      if Ch1 in ['0','2','7'] then LocalAttr:=LocalAttr and not taDoubleWide
                              else ReadAttrPrintFx:=Code+ch+ch1;
     end;
 '5':LocalAttr:=LocalAttr or taDoubleWide;
 '*':LocalAttr:=0;
 else
  ReadAttrPrintFX:=Code+ch;
 end;
 GlobalAttr:=LocalAttr;
end;
Function ReadAttrWD(var F:Text;Code:Char):String;far;
var Bt,Mask:Byte;i:Integer;
Const Recode:Array[1..8] of Byte=(taScript,taUnderline,taSuperScript,taSubScript,
         taDoubleWide,taItalic,taBold,taInverse);
begin
 Read(F,Char(Bt));
 {Swapping bits}
 Mask:=1;

 LocalAttr:=0;
 For i:=1 to 8 do
  begin
   if Bt and Mask<>0 then LocalAttr:=LocalAttr or Recode[i];
   Mask:=Mask shl 1;
  end;
 ReadAttrWD:='';
end;
Function ReadAttrEpson(var F:Text;Code:Char):String;far;
var Ch,Ch1:Char;
begin
 ReadAttrEpson:='';
 if Code=#14 then  begin LocalAttr:=LocalAttr or taDoubleWide; exit end
 else
 if Code=#20 then begin LocalAttr:=LocalAttr and not taDoubleWide;exit end;
 Read(F,ch);
 Case Ch of
 '-' :begin
      Read(F,Ch1);
      if Ord(ch1) and 1 = 0 then LocalAttr:=LocalAttr and not taUnderLine
                            else LocalAttr:=LocalAttr or taUnderLine;
     end;
  'W':begin
       Read(F,Ch1);
      if Ord(ch1) and 1 = 0 then LocalAttr:=LocalAttr and not taDoubleWide
                            else LocalAttr:=LocalAttr or taDoubleWide;
      end;
  'E','G':LocalAttr:=LocalAttr or taBold;
  'F','H':LocalAttr:=LocalAttr and not taBold;
  '4':LocalAttr:=LocalAttr or taItalic;
  '5':LocalAttr:=LocalAttr and not taItalic;
  'S':begin
       Read(F,ch1);
        if ord(ch1) and 1=0 then
         LocalAttr:=LocalAttr and not taSubscript or taSuperScript
         else
         LocalAttr:=LocalAttr and not taSuperScript or taSubScript
       end;
    'T':LocalAttr:=LocalAttr and not (taSubScript+taSuperScript);
    else
     ReadAttrEpson:=Code+Ch;
     exit;
   end;
  GlobalAttr:=LocalAttr;
end;
{------------ ⥭ ப ---------------}
Procedure GetSF(var F:Text;var TextStr,AttrStr:String);
Type TReadFunc=Function(var F:Text;Code:Char):String;
Const ReadAttr:Array[TFormat]of TReadFunc=(ReadAttrPlain,ReadAttrPlain,ReadAttrPlain,
   ReadAttrMim,ReadAttrWD,ReadAttrLex,ReadAttrPrintFX,ReadAttrEpson);
var TmpStr:String;
    Recognition:Boolean;
Const Ch:Char=#13;
begin
 LocalAttr:=GlobalAttr;
 TextStr:='';
 AttrStr:='';
 Recognition:=False;
 if ch=#13 then Read(F,Ch);
 While (Ch<>#10)and(ch<>#13) do
  begin
   if (inFmt=fmRecognize) then
    begin
     i:=Pos(Ch,ControlCodes);
     if i<>0 then
      begin
       if i>ord(fmEpson) then inFmt:=fmEpson
       else inFmt:=TFormat(i);
       Recognition:=True;
      end;
    end;
    if (inFmt<>fmRecognize)and(Ch=ControlCodes[ord(inFmt)])
     or(inFmt=fmEpson) and ((ch=#14)or(ch=#20)) then
    begin
     TmpStr:=ReadAttr[infmt](F,ch);
     TextStr:=TextStr+TmpStr;
     if (Recognition and (length(tmpStr)<>0))and(inFmt<>fmUnix) then
      {᫥⥫쭮   ࠢ饩}
     begin
      inFmt:=fmRecognize;
      Recognition:=False;
     end;
     For i:=1 to length(TmpStr) do TmpStr[i]:=Chr(LocalAttr);
     AttrStr:=AttrStr+TmpStr;
    end
   else
    begin
     TextStr:=TextStr+ch;
     AttrStr:=AttrStr+Chr(LocalAttr);
    end;
   Read(F,Ch);
  end;
   if Recognition then Writeln('Format is recognized as ',FormatName[inFmt]);
 if Ch=#13 then
 begin
  Read(F,ch);
  if (Ch=#10) then
   Read(F,Ch);
  end else Read(F,Ch);
end;
{--------------  ࠢ  ----}
{  ࠬ - , 㤠 
                -  祭 ਡ⮢
               EndLine - ਧ  ப
               ।饥 祭 ਡ ࠭
                쭮 ६ PrevAttr
                㤠 }
Procedure PutAttrPlain(var F:Text;Attr:Byte;EndLine:Boolean);far;
begin
End;
Procedure PutAttrMim(var F:Text;Attr:Byte;EndLine:Boolean);far;
var tmpByte:Byte;
begin
 if not EndLine then
 begin
  if Attr and taScript<>0 then tmpByte:=Attr or taInverse else tmpByte:=Attr;
  Write(F,^B,chr(tmpByte or $80))
 end;
 PrevAttr:=Attr;
end;
Procedure PutAttrLex(var F:Text;Attr:Byte;EndLine:Boolean);far;
Const UdlChar:Array[Boolean] of Char=('.','_');
var     Font:Byte;
begin
 Font:=0;
 if not EndLine then
  begin
   if Attr xor PrevAttr and taUnderLine<>0 then
     Write(F,#255,UdlChar[Attr and taUnderLine<>0]);
   if Attr xor PrevAttr and (taItalic+taBold+taSuperScript+taSubScript)<>0 then
   begin
    if Attr and (taSuperScript+taSubScript)<>0 then
      begin
       if Attr and taSuperScript<>0 then font:=5
                                    else Font:=4;
      end
     else
      if Attr and taItalic<>0 then Font:=1;
    if Attr and taBold<>0 then font:=Font or 2;
    Write(F,#255,Font);
   end;
  end;
 PrevAttr:=Attr;
end;
Procedure PutAttrWd(var F:Text;Attr:Byte;EndLine:Boolean);far;
var Bt,Mask:Byte;i:Integer;
Const Recode:Array[1..8] of Byte=(taScript,taUnderline,taSuperScript,taSubScript,
         taDoubleWide,taItalic,taBold,taInverse);
begin
 if not EndLine then
 begin
  {Swapping bits}
  Mask:=1;
  Bt:=0;
  For i:=1 to 8 do
   begin
    if Attr and Recode[i]<>0 then Bt:=Bt or Mask;
    Mask:=Mask shl 1;
   end;
  Write(F,#0,chr(Bt));
 end;
 PrevAttr:=Attr;
end;
Procedure PutAttrPrintFx(var F:Text;Attr:Byte;EndLine:Boolean);far;
Procedure WriteCode(Code:String);
begin
 Write(F,'\',code);
end;
begin
 if EndLine then exit;
 {㪮/}
 if (Attr xor Prevattr) and taScript<>0 then
    if Attr and taScript=0 then WriteCode('') else WriteCode('');
 {/}
 if (Attr xor Prevattr) and taBold<>0 then
    if Attr and taBold=0 then WriteCode('') else WriteCode('');
 {ப/㧪}
 if (Attr xor Prevattr) and taDoubleWide<>0 then
    if Attr and taDoubleWide=0 then WriteCode('10') else WriteCode('5');
 PrevAttr:=Attr;
end;
Procedure PutAttrEpson(var F:Text;Attr:Byte;EndLine:Boolean);far;
Procedure WriteCode(Code:String);
begin
 Write(F,#27,code);
end;
begin
 if EndLine then exit;
 if Attr XOR prevAttr or not (TaScript+taInverse)=0 then exit; {  㬥 Epson 
      -㪮᭮  ᭮}
 {୮}
 if (Attr xor Prevattr) and taBold<>0 then
    if Attr and taBold=0 then WriteCode('H') else WriteCode('G');
 {ᨢ}
 if (Attr xor Prevattr) and taItalic<>0 then
    if Attr and taItalic=0 then WriteCode('5') else WriteCode('4');
 {ப/㧪}
 if (Attr xor Prevattr) and taDoubleWide<>0 then
    if Attr and taDoubleWide=0 then WriteCode('W'#0) else WriteCode('W'#1);
 {ન}
 if (Attr xor Prevattr) and taUnderLine<>0 then
    if Attr and taUnderLine=0 then WriteCode('-'#0) else WriteCode('-'#1);
 {}
 if (Attr xor PrevAttr) and (taSuperScript+taSubScript)<>0 then
  case Attr and (taSuperScript+taSubScript) of
  taSuperScript,taSubScript+taSuperScript:WriteCode('S'#0);
  taSubScript:WriteCode('S'#1);
  0:WriteCode('T');
  end;
  PrevAttr:=Attr;
end;
{-----------  ப}
Procedure PutSf(Var F:TExt;TextStr,AttrStr:String);
Type TPutAttr=Procedure(var F:Text;Attr:Byte;EndLine:Boolean);
Const PutAttr:Array[TFormat]of TPutAttr=(PutAttrPlain,PutAttrPlain,PutAttrPlain,
   PutAttrMim,PutAttrWD,PutAttrLex,PutAttrPrintFX,PutAttrEpson);
var i:Integer;
begin
 For i:=1 To Length(TextStr) do
  begin
    if PrevAttr<>ord(AttrStr[i]) then
     PutAttr[OutFmt](F,Ord(AttrStr[i]),False);
    Write(F,TextStr[i]);
  end;
  PutAttr[OutFmt](F,taNormal,True);
  Writeln(F);
end;
Procedure RemoveBackspaces(var Txt,Attr:String);
begin
 i:=2;
 While i<Length(Txt) do
  begin
   if Txt[i]=#8 then
    begin
     if Txt[i-1]='_' then
      begin
        if txt[i+1]='_' then
         begin
          if (I>2)and((ord(Attr[i-2]) and(taUnderLine+taBold))<>0) then
             Attr[i+1]:=Attr[i-2]
            else Attr[i+1]:=chr(ord(Attr[i+1])+taBold);
         end
        else Attr[i+1]:=chr(ord(Attr[i+1]) or taUnderline);
        Delete(Txt,i-1,2);
        Delete(Attr,i-1,2);
      end else
     begin
     if Txt[i+1]=Txt[i-1] then
       Attr[i-1]:=Chr(Ord(Attr[i-1])or taBold)
      else if
       Txt[i+1]='_' then Attr[i-1]:=Chr(Ord(Attr[i-1])or taUnderline)
      else txt[i-1]:=txt[i+1];
     Delete(Txt,i,2);
     Delete(Attr,i,2);
     end
    end
   else inc(i);
  end;
end;
Procedure InsertBackSpaces(var Txt,Attr:String);
var i:integer;
begin
 i:=1;
 While i<=length(Txt) do
  begin
   if ord(Attr[i]) and taBold<>0 then
    begin
     Insert(#8+Txt[i],Txt,i+1);
     Insert(#0#0,Attr,I);
     inc(i,2);
    end;
   if ord(Attr[i]) and taUnderline<>0 then
    begin
     Insert(#8'_',Txt,i+1);
     Insert(#0#0,Attr,I);
     inc(i,2);
    end;
   inc(i);
  end;
end;
begin
{**************   ****************}
 Writeln('SoftWeyr text attribute converter. Version 3.20');
 Writeln('Copyright (C)  by Vitus Wagner,1994-95');
 {⠭ த ᮢ᪨ ࠡ稪 訡}
 SetIntVec($24,SaveInt24);
 {  ப}
 InFileName:='';
 OutFileName:='';
 InFmt:=fmRecognize;
 OutFmt:=fmRecognize;
 FormatCount:=0;
 if ParamCount=0 then Help;
 For i:=1 to ParamCount do
  begin
   S:=ParamStr(i);
   if S[1]<>'/' then
  begin
    {Filename parameter}
   if InFileName='' then InfileName:=S
    else if OutFileName='' then OutFileName:=S else
     Error('Too many file names in command line')
  end
   else
  begin
   {format parameter}
   if Length(S)=1 then Error('Invalid switch '+S+' in command line');
   if (FormatCount=0) and (OutFileName='') then inFmt:=FormatType(Upcase(S[2]))
    else
     if FormatCount=1 then OutFmt:=FormatType(Upcase(S[2]))
      else Error('Too many format specifiers in command line');
  end;
  end;
  if InFileName='' then
   Error('No input file specified');
  if OutFmt=fmRecognize then OutFmt:=fmPlain;
  if (inFmt=fmPlain) or (OutFmt=InFmt) then
   begin
    Writeln('No conversion needed');
    Halt;
   end;
  {⨥ 䠩 }
  BufSize:=MaxAvail div 2;
  if BufSize>65521 then bufSize:=65521;
  if OutFileName='' then begin OutFileName:=InFileName;Backup(InFileName) end;
  Assign(inF,InFileName);
  if BufSize>128 then
  begin
   GetMem(InBuf,BufSize);
   SetTextBuf(InF,InBuf^,BufSize);
  end;
  Reset(InF);
  i:=IOResult;
  if i<>0 then
   FileError(i,InFileName);
  Assign(OutF,OutFileName);
  if BufSize>128 then
  begin
   GetMem(OutBuf,BufSize);
   SetTextBuf(OutF,OutBuf^,BufSize);
  end;
  Rewrite(OutF);
  i:=IOResult;
  if i<>0 then
   FileError(i,OutFileName);
  Writeln('Input format:',FormatName[inFmt]);
  Writeln('Output format:',FormatName[outFmt]);
 {堫!...}
 GlobalAttr:=0;
 PrevAttr:=0;
 Repeat
  GetSF(Inf,S,A);
  i:= IOResult;
  if I<>0 then ShutDown(i,InFileName);
  if inFmt=fmUnix then RemoveBackspaces(S,A);
  if outFmt=fmUnix then InsertBackspaces(S,A);
  PutSF(Outf,S,A);
  i:= IOResult;
  if I<>0 then ShutDown(i,OutFileName);
 Until eof(InF);
 if OutFmt=fmMim then Write(OutF,^Z);
 Close(Inf);
 Close(OutF);
 if inFmt=fmRecognize then Writeln('Input format not recognized, no changes made') else
 Writeln('Conversion successiful');
end.